////////////////////////////////////////////////////////////////
printf('modele de commande 1, G+C*lambda+PD');
timer();
for i=1:10000, 
	g=gravite(q);
	c=jacobien_contact(q);
	g+(c'*lambda);
end;
timer()

////////////////////////////////////////////////////////////////
printf('temps de calcul de M');
timer();
for i=1:10000, 
	contact(q);
end;
timer()

////////////////////////////////////////////////////////////////
printf('modele de commande 2, G+C*lambda+M*PD');
timer();
for i=1:10000, 
	c=jacobien_contact(q);
	m=inertie(q);
	pd=ones(21,1);
	(c'*lambda)+m*pd;
end;
timer()

////////////////////////////////////////////////////////////////
printf('modele de commande 3, G+C*lambda+M*H^-1(PD-h+sddot)');
timer();
for i=1:10000, 
	c=jacobien_contact(q);
	m=inertie(q);
	H=jacobien_sortie(q);
	h=hessiens_sortie(q,qdot);
	v=sortie(q);
	(c'*lambda)+m*inv(H)*(v-h);
end;
timer()

////////////////////////////////////////////////////////////////
printf('modele de commande 3 bis, G+C*lambda+M*H*(PD-h+sddot)');
timer();
for i=1:10000, 
	c=jacobien_contact(q);
	m=inertie(q);
	H=jacobien_sortie(q);
	h=hessiens_sortie(q,qdot);
	v=sortie(q);
	(c'*lambda)+m*H*(v-h);
end;
timer()

////////////////////////////////////////////////////////////////
printf('modele de commande 4: QP');
timer();
  un = ones(size(c, 1)/3, 1);
  ze = zeros(un);
  UN = diag(un);
  ZE = diag(ze);
  bUN = mu0/sqrt(2-sqrt(2))*UN;
  aUN = bUN/sqrt(2);
  A = [-UN, aUN,  ZE, un;
        UN, aUN,  ZE, un;
        ZE, aUN,  UN, un;
        ZE, aUN, -UN, un;
        UN, bUN,  UN, un;
       -UN, bUN,  UN, un;
        UN, bUN, -UN, un;
       -UN, bUN, -UN, un];
  p = [zeros(39, 1); 1];
  Q = diag(p); Q($) = 0;
  T = [eye(15, 15); zeros(6, 15)];
  CC = [T, c', zeros(q); zeros(size(A, 1), size(T, 2)), -A];
  bb = [ones(21, 1); zeros(size(A, 1), 1)];
for i=1:10000, 
	M = inertie(q);
  	C = jacobien_contact(q);
  	H = jacobien_sortie(q);
  	h = hessiens_sortie(q, qdot);
	v = sortie(q);
	
	D = M*inv(H)*(v-h);
  
  	qld(Q, p, CC, bb, -1e10*ones(p), 1e10*ones(p),15, 1e-13);
end;
timer()

